//***************************************************
// `uqUSccRQp̓mFvO
//   ݂bot́u`uqUScaRQgpĂ
//   botNbN͂Slg
//
//  BOAD Check Program for "AVR64DB32"
//   CPU Clock : 4MHz
//
//  File name:main.c  
//
//  2025/04/13 NEW(TAB4) Taishi
//***************************************************  

#define F_CPU 4000000UL

#include <avr/io.h>
#include <util/delay.h>		// _delay_us(), _delay_ms()p

// ***************************************************
// `FbNvO
//  Ĺ̈𐶂
//#define	BIT1_CHECK			// Prbgo͂̂nm^neeikdc̓_Łj
#define	SWITCH_CHECK	// oeUXCb`̃`FbN
//#define	PORT_CHECK		// Srbg̏o̓`FbNio`Uj
// ***************************************************

// *****************************************
//  CvO
//
//   Lȃ|[g
//   PA 0 -- 7
//   PB Non
//   PC 0 -- 3
//   PD 1 -- 7
//   PE Non
//   PF 0 -- 6
// *****************************************
int main(void)
{

#ifdef	BIT1_CHECK
// ****************************************************************
//    Prbgo͂̃`FbNikdc̓_Łj
// ****************************************************************
	{
		PORTA_DIRSET = 0b10000000;	// PORT-A7 output
		
		while(1){
			PORTA_OUTTGL = 0b10000000;	// PA7 ON or OFF
			_delay_ms(500);
		}
		
	}
#endif

#ifdef	SWITCH_CHECK
// ****************************************************************
// XCb`̓̓`FbN
// ****************************************************************

	{
		PORTA_DIRSET = 0b10000000;		// PA7 output
		PORTF_DIRCLR = 0b01000000;		// PF6:input
		PORTF.PIN6CTRL = 0b00001000;	// PF6 Pullup
		while(1){
			if((PORTF_IN & 0b01000000) == 0){
				PORTA_OUTSET = 0b10000000;	// PA7 ON
			}else{
				PORTA_OUTCLR = 0b10000000;	// PA7 OFF
			}
		}
	}
	
#endif
			
#ifdef	PORT_CHECK
// ****************************************************************
// S|[g̏o̓rbg̃`FbN
//  rbgɏԂɂgo͂
// ****************************************************************

// o̓rbg̃`FbN
	{
		unsigned char	od;
		unsigned char	uc;
		unsigned char	nmax;

		PORTA_DIRSET = 0b11111111;	// PORT-A all output
		PORTC_DIRSET = 0b00001111;	// PORT-B PC0 -- PC3 output
		PORTD_DIRSET = 0b11111110;	// PORT-D PD1 -- PD7 output
		PORTF_DIRSET = 0b00111111;	// PORT-F PF0 -- PF5 output
		PORTF_DIRCLR = 0b01000000;	// PORT-F PF6 input

		while(1){

			// ********* PORT-A ****************
			nmax = 7;						// NofOutBit
			od = 0x01;						// Init. Port Data
			for(uc=0; uc <= nmax; uc++,od <<= 1){
				PORTA_OUT = od;				// Port-A Data Output
				_delay_ms(500);
			}

			// ********* PORT-C ****************
			nmax = 4;						// NofOutBit
			od = 0x01;						// Init. Port Data
			for(uc=0; uc <= nmax; uc++,od <<= 1){
				PORTC_OUT = od;				// Port-C Data Output
				_delay_ms(500);
			}

			// ********* PORT-D ****************
			nmax = 6;						// NofOutBit
			od = 0b0000010;					// Init. Port Data
			for(uc=0; uc <= nmax; uc++,od <<= 1){
				PORTD_OUT = od;				// Port-D Data Output
				_delay_ms(500);
			}

			// ********* PORT-F ****************
			nmax = 6;						// NofOutBit
			od = 0x01;						// Init. Port Data
			for(uc=0; uc <= nmax; uc++,od <<= 1){
				PORTF_OUT = od;				// Port-F Data Output
				_delay_ms(500);
			}

			_delay_ms(1000);

			// ********* Output All Clear ****************
			PORTA_OUTCLR = 0b11111111;
			PORTC_OUTCLR = 0b00001111;	// PORT-B PC0 -- PC3 output
			PORTD_OUTCLR = 0b11111110;	// PORT-D PD1 -- PD7 output
			PORTF_OUTCLR = 0b00111111;	// PORT-F PF0,1,6 output
		}
    }
#endif

}
